﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;

namespace NetworkConfigurator
{
    /// <summary>
    /// Interaction logic for AllFlowsWindow.xaml
    /// </summary>
    public partial class AllFlowsWindow : Window
    {
        private MainWindow mainWindow;
        private List<Flow> Flows;
        public AllFlowsWindow()
        {
            InitializeComponent();
            mainWindow = (MainWindow)Application.Current.MainWindow;
            Flows = mainWindow.configurationArea.Flows;
            flowsListBox.DataContext = Flows;
        }

        private void RemoveButton_Click(object sender, RoutedEventArgs e)
        {
            Button b = sender as Button;
            Flow comm = b.DataContext as Flow;

            var linksPartOfFlow = mainWindow.configurationArea.GetLinksPartOfFlow(comm);
            foreach (var link in linksPartOfFlow)
            {
                link.UsedBandwidth -= comm.Throughput;
            }
            Flows.Remove(comm);
            flowsListBox.ItemsSource = null;
            flowsListBox.ItemsSource = Flows;
            if (Flows.Count == 0)
                Close();
        }

        private async void Edit_Click(object sender, RoutedEventArgs e)
        {
            Button b = sender as Button;
            Flow comm = b.DataContext as Flow;
            mainWindow.configurationArea.Source = comm.Source;
            mainWindow.configurationArea.Destination = comm.Destination;
            IsEnabled = false;
            await mainWindow.configurationArea.SetFlow();
            IsEnabled = true;
            flowsListBox.ItemsSource = null;
            flowsListBox.ItemsSource = Flows;
            if (Flows.Count == 0)
            {
                Close();
            }
        }
    }
}
