﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;

namespace NetworkConfigurator.Converters
{
    class ValueToVisibilityConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            string param = parameter as string;
            switch (param)
            {
                case "FreeNICs":
                    ObservableCollection<NetworkInterfaceCard> NICs = value as ObservableCollection<NetworkInterfaceCard>;
                    foreach (var nic in NICs)
                    {
                        if(nic.PluggedLink == null)
                            return Visibility.Collapsed;
                    }
                    return Visibility.Visible;
                case "NICVisibility":
                    return value == null ? Visibility.Visible : Visibility.Collapsed;
                case "OccupiedNICs":
                    ObservableCollection<NetworkInterfaceCard> NICs1 = value as ObservableCollection<NetworkInterfaceCard>;
                    foreach (var nic in NICs1)
                    {
                        if (nic.PluggedLink == null)
                            return Visibility.Visible;
                    }
                    return Visibility.Collapsed;
            }
            return Visibility.Collapsed;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
