﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace NetworkConfigurator
{
    /// <summary>
    /// Interaction logic for LinkEditorWindow.xaml
    /// </summary>
    public partial class LinkEditorWindow : Window
    {
        private Window parent;
        public LinkEditorWindow(LinkControl lc, Window parent)
        {
            InitializeComponent();
            Left = parent.Left + parent.Width / 2 - Width / 2;
            Top = parent.Top + parent.Height / 2 - Height / 2;
            this.parent = parent;
            DataContext = lc;
        }

        private void TextBox_PreviewTextInput(object sender, TextCompositionEventArgs e)
        {
            e.Handled = !IsValid(((TextBox)sender).Text + e.Text);
        }

        public static bool IsValid(string str)
        {
            float i;
            return float.TryParse(str, out i) && i >= 0 && i <= LinkControl.BandwidthUpperLimit;
        }
    }
}
