﻿using NetworkConfigurator.Converters;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace NetworkConfigurator
{
    /// <summary>
    /// Interaction logic for NetworkInterfaceCardSelection.xaml
    /// </summary>
    public partial class NetworkInterfaceCardSelection : Window
    {
        private LinkControl link;
        private string side;
        private Router r;

        public NetworkInterfaceCardSelection(Router r, LinkControl link, string side)
        {
            InitializeComponent();
            this.link = link;
            this.side = side;
            DataContext = r;
            this.r = r;
            var mainWindow = (MainWindow)Application.Current.MainWindow;
            Left = mainWindow.Left + mainWindow.Width / 2 - Width / 2;
            Top = mainWindow.Top +  mainWindow.Height / 2 - Height / 2;
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            var nic = NICComboBox.SelectedItem as NetworkInterfaceCard;

            var converter = new ValueToVisibilityConverter();

            var IsAllOccupied = (Visibility)converter.Convert(r.InterfaceCards, null, "OccupiedNICs", null) == Visibility.Visible ?
                false : true;

            // Visible == there are free NICs == false.
            
            if (!IsAllOccupied)
            {
                if(nic == null)
                {
                    closingErrorTextBlock.Visibility = Visibility.Visible;
                    e.Cancel = true;
                }
                else
                {
                    nic.PluggedLink = link;
                    if (side == "start")
                        link.PortIndexStart = r.InterfaceCards.IndexOf(nic);
                    else
                        link.PortIndexEnd = r.InterfaceCards.IndexOf(nic);
                }
            }
        }
    }
}
