﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;

namespace NetworkConfigurator
{
    public class PC : ToolboxControl
    {
        public NetworkInterfaceCard InterfaceCard { get; set; }

        public PC():base()
        {
            ControlName = "PC " + ID;
            ImageSource = "Images/pc.png";
            InterfaceCard = new NetworkInterfaceCard
            {
                IPAddress = "1.2.3.4",
                MACAddress = "aa:bb:cc:dd:ee:ff"
            };
        }

        public PC(ToolboxControl tc) : base(tc)
        {
            ControlName = tc.ControlName + " " + ID;
            InterfaceCard = new NetworkInterfaceCard
            {
                IPAddress = "1.2.3.4",
                MACAddress = "aa:bb:cc:dd:ee:ff"
            };
        }

        protected override void OnMouseDoubleClick(MouseButtonEventArgs e)
        {
            base.OnMouseDoubleClick(e);
            if (ControlNameTextBlock.IsMouseOver)
                return;
            MainWindow window = (MainWindow)Application.Current.MainWindow;

            PCEditorWindow w = new PCEditorWindow(this, window);
            w.ShowDialog();
        }

        protected override void OnDrop(DragEventArgs e)
        {
            e.Handled = true;
            if (e.Data.GetDataPresent(MainWindow.LinkControlName))
            {
                LinkControl link = (LinkControl)e.Data.GetData(MainWindow.LinkControlName);
                if (InterfaceCard.PluggedLink == null)
                {
                    InterfaceCard.PluggedLink = link;
                    string side = (string)e.Data.GetData("string");
                    if (side == "start")
                        link.PortIndexStart = 0;
                    else
                        link.PortIndexEnd = 0;
                    base.OnDrop(e);
                }
                else
                {
                    MessageBox.Show("The PC's network interface card is already occupied. Unplug then try again.", "NIC occupied",
                        MessageBoxButton.OK, MessageBoxImage.Exclamation);
                    return;
                }
            }
        }
    }
}
